// Insteo JSON Data v1 copyright Insteo 2021 all rights reserved

var appKey = null;
var feedKey = null;
var containerItemLength = null;
var adsLength = 0;
var title = null;
var description = null;
var content = null;
var TitleColor = null;
var DescriptionColor = null;
var ContentColor = null;
var HeaderColor = null;
var SubheadColor = null;
var BodyColor = null;
var BoxColor = null;
var SpecialFeature = null;
var backgroundImg = null;
var TitleImageID = null;
var BoxBackgroundImageID = null;
var FloorName = null;
var FloorCount = null;
var svgFile = null;
var initialFloor = null;
var mapID;
var idleTime = 0;
var cat = [];
var catOrder = '';
var idleInterval;
var idleTimeout;
var photoData = [];
var AnimationTiming = 5;
var videoUrl = '';
var speechUrl = '';
var HelperFeed3 = '';
var dataString = '';

//Interval ID
var initial;
var URLrandom = Math.floor((Math.random() * 1000) + 1);
//Get keys for app and content 
function getKeys() {
    var vars = [],
        hash;
    var q = document.URL.split('?')[1];
    if (q !== undefined) {
        q = q.split('&');
        for (var i = 0; i < q.length; i++) {
            hash = q[i].split('=');
            vars.push(hash[1]);
            vars[hash[0]] = hash[1];
        }
    }
    appKey = vars['k'];
    feedKey = vars['vfk'];
}

var newImgURL = [];
function fixCloudURL(urlToSplit, cloud) {
    if (urlToSplit != undefined) {
        newImgURL = [];
        var splitImage = urlToSplit.split('/');
        //Use for loop to put URL together
        for (var i = 0; i < splitImage.length; i++) {
            if (i === 0) {
                newImgURL += splitImage[0];
            } else {
                newImgURL += '/';
                newImgURL += splitImage[i];
                if (i == 5) {
                    newImgURL += cloud;
                }
            } //end of if

        } //end of for
        newImgURL = newImgURL.replace('http:', 'https:');
        return newImgURL;
    }
}

//This function populates your list
function LoadData() {
    var URLFeed = "https://sheets.googleapis.com/v4/spreadsheets/1HphgLQ0QAQxk1hroonctcOYf4wna38TnXb4uVxekKWU/values/Sheet1?alt=json&key=AIzaSyDYeV6zJukYyggbaSt9ZBjxHxbBgODt9L8";

    $.ajax({
        url: URLFeed,
        type: "GET",
        contentType: "application/javascript",
        dataType: "jsonp",
        error: function () {
            setTimeout(LoadData, 30000);
        },
        success: function (data) {
            if (dataString == JSON.stringify(data)) return;
            dataString = JSON.stringify(data);
            console.log("Data: \n" + URLFeed);

            $("#divDirectory").empty();

            var sb = "";
            var count = 0;

            // get all entry
            var listOfObjects = [];
            var item = data["values"];
            $.each(item, function (i1, item1) {
                if (i1 < 1) return;
                var singleObj = {};
                singleObj["Name"] = item1[0];
                singleObj["Description"] = item1[2];
                singleObj["About"] = item1[1];
                singleObj["Video"] = item1[3];
                singleObj["SpeechVideo"] = item1[4];
                singleObj["Category"] = item1[5];
                singleObj["Image"] = item1[6];
                listOfObjects.push(singleObj);
            });

            var totalItems = listOfObjects.length;

                
                ////SORTING FUNCTION/////
            var objs = listOfObjects;
                var cmp = function (a, b) {
                    if (a > b) return +1;
                    if (a < b) return -1;
                    return 0;
                };				
                objs.sort(function (a, b) {
                    return cmp(a.Name, b.Name) || cmp(a.Name, b.Name);
                });

                $.each(listOfObjects, function (i1, item1) {
                    count = count + 1;
                    var Name = item1.Name;
                    var Description = item1.Description;
                    var Category = item1.Category;
                    var Image = item1.Image;
                    var about = item1.About;
                    var video = item1.Video;
                    var speechVideo = item1.SpeechVideo;

                    if (Name == undefined || Name == "null" || Name == null) {
                        Name = "";
                    } else {
                        Name = Name.replace(/['"]+/g, '');
                    }
                    if (Description == undefined || Description == "null" || Description == null) {
                        Description = "";
                    } else {
                        Description = Description.replace(/['"]+/g, '');
                    }

                    if (Category == undefined || Category == 'null' || Category == null) {
                        Category = '---';
                    }
                    if (about == undefined || about == "null" || about == null) {
                        about = "";
                    } else if (about != "") {
                        about = about.replace(/['"]+/g, '');
                        about = "Year Inducted: " + about;
                    }
                    if (Image == undefined || Image == 'null' || Image == null) {
                        Image = "";
                    }
                    if (video == undefined || video == 'null' || video == null) {
                        video = "";
                    }
                    if (speechVideo == undefined || speechVideo == 'null' || speechVideo == null) {
                        speechVideo = "";
                    }

                    var searchedValue = Name + "," + Description + "," + about;
                    photoData[count] = Name + "##" + Description + "##" + about + "##" + Image + "##" + video + "##" + speechVideo;
					
                    if (Image.toLowerCase().indexOf("res.cloudinary.com") >= 0) {
                        Image = fixCloudURL(Image, '/w_170,h_243'); //'/c_crop,g_face/w_170,h_210'
                    }
					
                    cat.push(Category.trim());
                    sb = sb + '<li id="li' + count + '" data-name="' + searchedValue + '" onClick="RoomFill(\'' + count + '\')" class="directory ' + Category.trim().replace(" ", "-") + '"><img class="photo" src="' + Image + '"></img><span class="namelist">' + Name + '</span></li>';
                    
                });

            $("#divDirectory").append("<ul class='directorylist'>" + sb + "</ul>");
            
            //Set Interface
            setInterface();
            $('#btnAll').click();
        }
    });
}

function setInterface() {
    var URLrandom = Math.floor((Math.random() * 1000) + 1);
    //var URLInstructions = 'https://api.insteo.com/api/1/AppService.svc/GetAppContentInstructionList?type=JSON&key=' + appKey + '&ran=' + URLrandom;
	var URLInstructions = 'getappcontentinstructionlist.txt';
    console.log('Design: \n' + URLInstructions);
    $.ajax({
        url: URLInstructions,
        data: '',
        type: "GET",
        contentType: "application/javascript",
		dataType: "json",
        error: function () {
        },
        success: function (data) {
            $("#divFloor").empty();
            $.each(data, function (i, item) {
                $.each(item.instructions, function (i1, item1) {
                    $.each(item1.instruction, function (i2, item2) {

                        BodyColor = item2.BodyColor;
                        title = item2.title;
                        TitleColor = item2.TitleColor;
                        HeaderColor = item2.HeaderColor;
                        ContentColor = item2.ContentColor;
                        DescriptionColor = item2.DescriptionColor;
                        BoxColor = item2.BoxColor;
                        backgroundImg = item2.UploadedFileID;
                        BoxBackgroundImageID = item2.BoxBackgroundImageID;
                        catOrder = item2.HelperFeed1;
                        description = item2.description;
                        SubheadColor = item2.SubheadColor;
                        AnimationTiming = item2.AnimationTiming;
                        var HelperFeed2 = item2.HelperFeed2;
                        HelperFeed3 =  item2.HelperFeed3;
                        var FontID3 = item2.FontID3;

                        if (HelperFeed3 == '' || HelperFeed3 == 'null' || HelperFeed3 == null || HelperFeed3 == undefined) {
                            HelperFeed3 = '';
                            $('.loop').hide();
                        } else {
                            $('#loop').attr('src', HelperFeed3);
                            $('.loop').show();
                        }

                        if ((BoxBackgroundImageID != 'null') && (BoxBackgroundImageID != '') && (BoxBackgroundImageID != undefined)) {
                            fixCloudURL(BoxBackgroundImageID);
                            var backImage = fixCloudURL(BoxBackgroundImageID, '/w_1920,h_1080');
                            $('.loop').css('background-image', 'url(' + backImage + ')');
                        }

                        if (AnimationTiming == '' || AnimationTiming == 'null' || AnimationTiming == null || AnimationTiming == undefined || AnimationTiming == '0') {
                            AnimationTiming = 10;
                        }
                        if (HelperFeed2 == '' || HelperFeed2 == 'null' || HelperFeed2 == null || HelperFeed2 == undefined) {
                            HelperFeed2 = 'off';
                        }

                        if (HelperFeed2.toLowerCase() == 'off') {
                            $('#imgSearch').hide();
                        }

                        $("#divCategory").empty();
                        //Adding category button
                        var uniques = cat.unique();
                        uniques.sort();
                        var catAll = '<img src="*** Broken Link ***" class="category-button"/><button type="button" id="btnALL" class="category" onClick="GetNameList(\'ALL\')">ALL</button>&nbsp;';
                        if (uniques.length <= 5) {
                            catAll = '<button type="button" id="btnALL" class="category" onClick="GetNameList(\'ALL\')">ALL</button>&nbsp;';
                        }
                        var catSB = catAll;
                        if (catOrder != '' && catOrder != undefined && catOrder != null) {
                            var catSorted = catOrder.split(",");
                            for (var i = 0; i < catSorted.length; i++) {
                                for (var k = 0; k < uniques.length; k++) {
                                    if (catSorted[i].toString().toLowerCase() != 'all') {
                                        if (catSorted[i].toString().toLowerCase().trim() == uniques[k].toString().toLowerCase().trim()) {
                                            var item = uniques[k];
                                            catSB = catSB + '<button type="button" id="btn' + item.replace(" ", "-") + '" class="category" onClick="GetNameList(\'' + item.replace(" ", "-") + '\')">' + item + '</button>&nbsp;';
                                            break;
                                        }
                                    } else {
                                        //catSB = catSB + catAll;
                                        break;
                                    }
                                }
                            }
                        } else {
                            //catSB = catall;
                            for (var i = 0; i < uniques.length; i++) {
                                var item = uniques[i];
                                catSB = catSB + '<button type="button" id="btn' + item.replace(" ", "-") + '" class="category" onClick="GetNameList(\'' + item.replace(" ", "-") + '\')">' + item + '</button>&nbsp;';
                            }
                        }
                        if (uniques.length > 5) {
                            catSB =catSB+ '<img src="*** Broken Link ***" class="category-button"/>';
                        }
                        $("#divCategory").append(catSB + "</br>");
                        resetAll();
                        
                        $('#title').text('' + title + '');
                        if (TitleColor != '' && TitleColor != 'null' && TitleColor != null && TitleColor != undefined) {
                            $('#title').css('color', '#' + TitleColor + '');
                            $('.category').css('color', '#' + TitleColor + '');
                        }

                        if (backgroundImg != '' && backgroundImg != 'null' && backgroundImg != null && backgroundImg != undefined) {
                            $('.Container').css('background-image', 'url(' + backgroundImg + ')');
                        } else if (BodyColor != '' && BodyColor != 'null' && BodyColor != null && BodyColor != undefined) {
                            $(".Container").css("background-color", "#" + BodyColor);
                        }

                        if (DescriptionColor != '' && DescriptionColor != 'null' && DescriptionColor != null && DescriptionColor != undefined) {
                            $('.namelist').css("color", "#" + DescriptionColor);
                            $('#name').css("color", "#" + DescriptionColor);                            
                            $('#desc').css("color", "#" + DescriptionColor);
                        }

                        if (HeaderColor != '' && HeaderColor != 'null' && HeaderColor != null && HeaderColor != undefined) {
                            $('.category').css("background-color", "#" + HeaderColor);
                        }

                        if (ContentColor != '' && ContentColor != 'null' && ContentColor != null && ContentColor != undefined) {
                            $('#photo').css('background-color', "#" + ContentColor);
                        }

                        if (BoxColor != '' && BoxColor != 'null' && BoxColor != null && BoxColor != undefined) {
                            $('#content').css("background-color", "#" + BoxColor);
                        }

                    });
                });
            });
        }
    });
}

Array.prototype.unique = function () {
    var arr = this;
    return $.grep(arr, function (v, i) {
        return $.inArray(v, arr) === i;
    });
}

function getSpeechVideo() {
    $('#bioVideo').attr('src', '');
    if (speechUrl != '') {
        $('#divGuard').show();
        $('#divModal').show();
        $('#divDetails').show();
        $('#bioVideo').attr('src', speechUrl);
    }
}

function getVideo() {
    $('#bioVideo').attr('src', '');
    if (videoUrl != '') {
        $('#divGuard').show();
        $('#divModal').show();
        $('#divDetails').show();
        $('#bioVideo').attr('src', videoUrl);
    }
}

function closeBox() {
    $('#bioVideo').attr('src', '');
    $('#divModal').hide();
    $('#divDetails').hide();
    $('#divGuard').hide();
}

function unEntity(str) {
    return $("<textarea></textarea>").html(str).text();
}

function RoomFill(id) {
    var data = photoData[id].split('##');
    var bigImage = data[3];
    if (bigImage.toLowerCase().indexOf("res.cloudinary.com") >= 0) {
        bigImage = fixCloudURL(bigImage, '/w_460,h_600');
    }
    
    $('#bigImage').attr('src', bigImage);
    $('#bigImage1').attr('src', bigImage);
    $('#name').html(data[0]);
    $('#desc').html(unEntity(data[1]));
    $('#about').html(data[2]);
    $('li.directory img').css('border', "none");
    //$('#li' + id + ' img').css('border', "2px solid white");
    videoUrl = data[4];
    speechUrl = data[5];
}

function GetNameList(cat) {
    if (cat.toLowerCase() == 'all') {
        $('li.directory').show();
    } else {
        $('li.directory').hide();
        $('li.' + cat).show();
    }

    if (HeaderColor != '' && HeaderColor != 'null' && HeaderColor != null && HeaderColor != undefined) {
        $('.category').css("background", "#" + HeaderColor);
    } else {
        $('.category').css("background", "#bfbfbf");
    }
    if (SubheadColor != '' && SubheadColor != 'null' && SubheadColor != null && SubheadColor != undefined) {
        $('#btn' + cat).css("background-color", "#" + SubheadColor);
    } else {
        $('#btn' + cat).css('background-color', 'grey');
    }

    $('#divDirectory').scrollTop(0);

    if ($('li.directory:visible').length > 0) {
        $('li.directory:visible')[0].click();
    }
}

function resetAll() {
    idleTime = 0;
    if ($('li.directory:visible').length > 0) {
        $('li.directory:visible')[0].click();
    }
}

function timerIncrement() {
    idleTime = idleTime + 1;
    //10 minutes after home page will popup
    if (idleTime >= 600 && HelperFeed3 != '') {
        idleTime = -18000;
        $('.loop').show();
        $('#loop').show();
        closeBox();
        $('#wrapper').hide();
        //checking loop layer touch
        focus();
        var listener = addEventListener('blur', function () {
            if (document.activeElement === document.getElementById('loop')) {
                hideLoop();
            }
        });
    }
}

function ReturnOverlay() {
    idleTime = -18000;
    $('.loop').show();
    $('#loop').show();
    $('#wrapper').hide();
    //checking loop layer touch
    focus();
    var listener = addEventListener('blur', function () {
        if (document.activeElement === document.getElementById('loop')) {
            hideLoop();
        }
    });
}

//get keyboard on search click
function GetSearchedName() {
    GetNameList('ALL');
    $('.lightbox').fadeIn();
    $('.spnMapClose').fadeIn();
    $('#search-input').focus();
    $('li.directory').hide();
}

function closeLightBox() {
    $('.lightbox').fadeOut();
    $('.spnMapClose').fadeOut();
    $("#search-input").val("");
    GetNameList('ALL');
}

function searchByName(name) {
    if (name.length > 0) {
        // make :contains selector case insensitive	
        $.expr[":"].contains = $.expr.createPseudo(function (arg) {
            return function (elem) {
                return $(elem).text().toUpperCase().indexOf(arg.toUpperCase()) >= 0;
            };
        });

        $('li.directory').hide();

        var searchResults = $("li.directory").filter(function () {
            var nameData = $(this).attr("data-name").toLowerCase().replace("'", ' ').replace("�", ' ');
            var seacrhData = name.toLowerCase().replace("'", ' ');
            return nameData.indexOf(seacrhData) > -1;
        });
        searchResults.css("display", "inline-block");
    } else if (name.length == 0) {
        $('li.directory').hide();
    }
}

function hoverOver(obj,obj2,obj3) {    
    $(obj).css("background-color", "#DEE");
    setTimeout(function () { $(obj2).css("visibility", "visible") }, 1000);
    $(obj).css("visibility", "visible");    
    $(obj).css("z-index", "10");
    $(obj3).css('border', '2px solid #fff');
    $(obj).animate({
        width: "600px",
        height: "900px",
        opacity: "1",
        left: "300px",
        top: "120px",
    }, 'slow');    
}

function hoverOut(obj, obj2, obj3) {
    var lft = '100px';
    var tp = '200px';
    $(obj3).css('border', 'none');
    $(obj).css("background-color", "#FFF");
    $(obj2).css("visibility", "hidden");
    $(obj).animate({
        width: "250px",
        height: "350px",
        opacity: "0",
        left: lft,
        top: tp,
    }, 1000, function () {
        $(obj).css("visibility", "hidden");
    });
}

function hideLoop() {
    $('#wrapper').show();
    GetNameList('ALL');
    $('.loop').hide();
    $('#loop').hide();
    //Increment the idle time counter every minute.
    idleTime = 0;
    clearInterval(idleInterval);
    idleInterval = setInterval(timerIncrement, 1000); // 1 sec
}

function setCSS() {
    var URLrandom = Math.floor((Math.random() * 1000) + 1);
    var URLcss = 'https://api.insteo.com/api/1/AppService.svc/GetAppCSS?type=JSON&key=' + appKey + '&ran=' + URLrandom;
    console.log("CSS: \n" + URLcss);
    $.ajax({
        url: URLcss,
        data: '',
        type: "GET",
        dataType: "text",
        error: function (xhr, status) { },
        success: function (data) {
            if (data != '') {
                var node = document.createElement('style');
                node.innerHTML = data;
                document.body.appendChild(node);
            }
        }
    });
}

$(document).ready(function () {
    //Get keys
    getKeys();
    setCSS();
    $('#wrapper').hide();
    //Set Content
    LoadData();

    //checking loop layer touch
    focus();
    var listener = addEventListener('blur', function () {
        if (document.activeElement === document.getElementById('loop')) {
            hideLoop();
        }
    });

    //Zero the idle timer on mouse movement.
    $(this).mousemove(function (e) {
        idleTime = 0;
    });
    $(this).keypress(function (e) {
        idleTime = 0;
    });
    $(this).on("touchstart", function (e) {
        idleTime = 0;
    });
    $(this).on("touchmove", function (e) {
        idleTime = 0;
    });

    $("#search-input").keyboard({
        autoAccept: true,
        // Auto-accept content even if the user presses escape (only works if `autoAccept` is `true`)
        autoAcceptOnEsc: true,
        usePreview: false,
        stayOpen: true,
        position: false,
        appendTo: ".lightbox",
        layout: 'custom',
        customLayout: {
            'default': [
                'q w e r t y u i o p {bksp}',
                'a s d f g h j k l',
                '{shift} z x c v b n m {shift}',
                '{space}'
            ],
            'shift': [
                'Q W E R T Y U I O P {bksp}',
                'A S D F G H J K L',
                '{shift} Z X C V B N M {shift}',
                '{space}'
            ]
        },
        repeatDelay: 10000,
        repeatRate: 10000

    });

    $('.ui-keyboard-input').bind('keyboardChange', function (e, keyboard, el) {
        if (e.action != "bksp") {
            var txt = 'Input ID of ' + el.id + ' has the accepted content of ' + el.value;
            
            var v = el.value;
            $("#search-input").val("");
            $("#search-input").val(v);
            searchByName($(this).val());
        }
        else {
            searchByName($(this).val());
        }
    });

    $(document).bind('touchend', onTouchControl);
    function onTouchControl(event) {
        // handler for touchend to interact with HTML controls
        if (event.type == 'touchend' && event.target) {
            //for everything else just run click function on element
            event.target.click();
        }

        //stop event propagation
        event.stopPropagation();
        event.preventDefault();
        return false;
    };

    $(".LBlistWrapper").bind('touchmove', onClickControl);
    function onClickControl(event) {
        // handler for touchend to interact with HTML controls
        if (event.type == 'touchmove' && event.target) {
            //for everything else just run click function on element
            event.target.scroll;
        }

        //stop event propagation
        event.stopPropagation();
        event.preventDefault();
        return false;
    };


    //Auto-Fit Window
    //Might have to change width number to 1080(portrait) or 1920(landscape)
    $(window).resize(function () {
        $('.Container').css({
            'zoom': $(window).height() / 1080,
            '-moz-transform': 'scale(' + $(window).height() / 1080 + ')',
            '-moz-transform-origin': '0 0'
        });
    });
    $(document).ready(function () {
        $('.Container').css({
            'zoom': $(window).height() / 1080,
            '-moz-transform': 'scale(' + $(window).height() / 1080 + ')',
            '-moz-transform-origin': '0 0'
        });
    });

});